                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*            environment            */
                     /*-----------------------------------*/

#include "SlipGrammar.h"

#include "SlipEnvironment.h"

/*------------------------------ private macros ------------------------------*/

#define EMPTY_FRAME Grammar_Empty_Vector_P

/*----------------------------- private variables ----------------------------*/

static VEC_type Current_environment_P;
static VEC_type Current_frame_P;
static VEC_type Global_frame_P;

/*----------------------------- public functions -----------------------------*/

VEC_type Environment_Create_Frame_M(UNS_type Frame_size)
  { if (Frame_size == 0)
      return EMPTY_FRAME;
    return make_VEC_M(Frame_size); }

UNS_type Environment_Get_Environment_size(VOI_type)
  { return (size_VEC(Current_environment_P) + 1); }

VEC_type Environment_Get_Environment(VOI_type)
  { return Current_environment_P; }

VEC_type Environment_Get_Frame(VOI_type)
  { return Current_frame_P; }

VEC_type Environment_Global_Frame(VOI_type)
  { return Global_frame_P; }

EXP_type Environment_Global_Get(UNS_type Scope,
                                UNS_type Offset)
  { EXP_type value;
    VEC_type frame;
    frame = Current_environment_P[Scope];
    value = frame[Offset];
    return value; }

VOI_type Environment_Global_Set(UNS_type Scope,
                                UNS_type Offset,
                                EXP_type Value)
  { VEC_type frame;
    frame = Current_environment_P[Scope];
    frame[Offset] = Value; }

VEC_type Environment_Grow_Environment_M(VOI_type)
  { UNS_type index,
             size;
    VEC_type environment,
             frame;
    size = size_VEC(Current_environment_P);
    environment = make_VEC_M(++size);
    for (index = 1;
         index < size;
         index++)
      { frame = Current_environment_P[index];
        environment[index] = frame; }
    environment[size] = Current_frame_P;
    return environment; }

EXP_type Environment_Local_Get(UNS_type Offset)
  { return Current_frame_P[Offset]; }

VOI_type Environment_Local_Set(UNS_type Offset,
                               EXP_type Value)
  { Current_frame_P[Offset] = Value; }

VOI_type Environment_Reset(VOI_type)
  { Current_environment_P = EMPTY_FRAME;
    Current_frame_P = Global_frame_P; }

VOI_type Environment_Rollback(UNS_type Global_frame_usage)
  { UNS_type index;
    Current_environment_P = EMPTY_FRAME;
    Current_frame_P = Global_frame_P;
    for (index = Global_frame_usage + 1;
         index <= Grammar_Global_Frame_Size;
         index += 1)
      Global_frame_P[index] = Grammar_Unspecified; }

VOI_type Environment_Set_Environment_And_Frame(VEC_type Environment,
                                               VEC_type Frame)
  { Current_environment_P = Environment;
    Current_frame_P = Frame; }

/*------------------------------ initialization ------------------------------*/

VOI_type Environment_Initialize_M(VOI_type)
  { Current_environment_P = EMPTY_FRAME;
    Global_frame_P = Current_frame_P = make_VEC_M(Grammar_Global_Frame_Size);
    REGISTER(Current_environment_P);
    REGISTER(Current_frame_P);
    REGISTER(Global_frame_P); }
