                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*               main                */
                     /*-----------------------------------*/

#include <setjmp.h>
#include <stdio.h>
#include <stdlib.h>

#include "SlipSlip.h"

#include "SlipMain.h"

#include "SlipNative.h"

/*------------------------------ private types -------------------------------*/

typedef enum { Initiate_REP  = 0,
               Terminate_REP = 1,
               Abort_REP     = 2,
               Proceed_REP   = 3 } TRA_type;

typedef jmp_buf EXI_type;

/*----------------------------- private variables ----------------------------*/

static UNS_type GC_count;
static EXI_type Trampoline;

/*----------------------------- public variables -----------------------------*/

CHR_type Main_Buffer[Main_Buffer_Size];

/*----------------------------- public functions -----------------------------*/

VOI_type Main_Error(TXT_type Message)
  { Slip_Print(Message);
    longjmp(Trampoline,
            Abort_REP); }

VOI_type Main_Fatal_Error(TXT_type Message)
  { Slip_Print("\n");
    Slip_Print(Message);
    exit(0); }

VOI_type Main_GC(VOI_type)
  { GC_count += 1; }

TXT_type Main_Load(TXT_type Path)
  { TXT_type input;
    Slip_Load(Path,
              &input);
    return input; }

VOI_type Main_Print(TXT_type Text)
  { Slip_Print(Text); }

VOI_type Main_Proceed(VOI_type)
  { longjmp(Trampoline,
            Proceed_REP); }

TXT_type Main_Read(VOI_type)
  { TXT_type input;
    Slip_Read(&input);
    return input; }

VOI_type Main_Terminate(VOI_type)
  { longjmp(Trampoline,
            Terminate_REP); }

/*------------------------------ exported functions --------------------------*/

void Slip_REPL(char   * Memory,
               unsigned Size)
  { TRA_type status;
    TXT_type input;
    sprintf(Main_Buffer, "Slip version 9 (memory size = %d bytes)", Size);
    Slip_Print(Main_Buffer);
    Native_Initialize_M((ADR_type)Memory,
                        (UNS_type)Size);
    do
      { GC_count = 0;
        if ((status = setjmp(Trampoline)) == Initiate_REP)
          { Slip_Print("\n>>>");
            Slip_Read(&input);
            Native_Run_C(input); }
        if (status == Abort_REP)
          Native_Reset_C();
        sprintf(Main_Buffer, "\ngc count = %lo", GC_count);
        Slip_Print(Main_Buffer); }
    while (status != Terminate_REP);
    Slip_Print("\nSlip terminated\n"); }
