                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*               memory              */
                     /*-----------------------------------*/

/*------------------------------ public types --------------------------------*/

typedef union PTR { CEL_type    cel;
                    union PTR * ptr; } * PTR_type;

/*------------------------------ public constants ----------------------------*/

enum { Memory_Cell_Bias         = 0x0000000000000008,
       Memory_Immediate_Maximum = 0x1FFFFFFFFFFFFFFF,
       Memory_Void_Value        = 0x0000000000000000 };

static const UNS_type Memory_Cell_Size = sizeof(CEL_type);

/*----------------------------- public prototypes ----------------------------*/

UNS_type      Memory_Available(VOI_type);
BLN_type          Memory_Claim(UNS_type);
PTR_type      Memory_Collect_C(PTR_type);
SGN_type  Memory_Get_Immediate(PTR_type);
UNS_type       Memory_Get_Size(PTR_type);
BYT_type        Memory_Get_Tag(PTR_type);
BLN_type   Memory_Is_Immediate(PTR_type);
PTR_type   Memory_Make_Chunk_M(BYT_type,
                               UNS_type);
PTR_type Memory_Make_Immediate(SGN_type);

/*------------------------------ initialization ------------------------------*/

VOI_type     Memory_Initialize(ADR_type,
                               UNS_type);
