                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*               stack               */
                     /*-----------------------------------*/

#include "SlipGrammar.h"

#include "SlipStack.h"

/*----------------------------- private constants ----------------------------*/

enum {   Initial_stack_size = 64,
       Stack_size_increment = 32 };

/*----------------------------- private variables ----------------------------*/

static VEC_type Stack_vector_P;

/*----------------------------------------------------------------------------*/

static UNS_type Stack_size;
static UNS_type Top_of_stack;

/*----------------------------- public functions -----------------------------*/

EXP_type Stack_Peek(VOI_type)
  { return Stack_vector_P[Top_of_stack]; }

VOI_type Stack_Poke(EXP_type Expression)
  { Stack_vector_P[Top_of_stack] = Expression; }

EXP_type Stack_Pop(VOI_type)
  { EXP_type expression;
    expression = Stack_vector_P[Top_of_stack];
    Stack_vector_P[Top_of_stack--] = Grammar_Unspecified;
    return expression; }

EXP_type Stack_Push_C(EXP_type Expression)
  { UNS_type index;
    VEC_type vector;
    Stack_vector_P[++Top_of_stack] = Expression;
    if (Top_of_stack == Stack_size)
      { Stack_size += Stack_size_increment;
        Grammar_Dynamic_Claim_C(Stack_size);
        vector = make_VEC_M(Stack_size);
        for (index = 1;
             index <= Top_of_stack;
             index++)
          vector[index] = Stack_vector_P[index];
        Stack_vector_P = vector;
        return Stack_Peek(); }
    return Stack_vector_P[Top_of_stack]; }                       // PROPAGATE!!!

VOI_type Stack_Reset(VOI_type)
  { while (Top_of_stack > 0)
      Stack_vector_P[Top_of_stack--] = Grammar_Unspecified; }

VOI_type Stack_Zap(VOI_type)
  { Stack_vector_P[Top_of_stack--] = Grammar_Unspecified; }

/*------------------------------ initialization ------------------------------*/

VOI_type Stack_Initialize_M(VOI_type)
  { Stack_size = Initial_stack_size;
    Top_of_stack = 0;
    Stack_vector_P = make_VEC_M(Initial_stack_size);
    REGISTER(Stack_vector_P); }