                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*              threads              */
                     /*-----------------------------------*/

#include "SlipGrammar.h"

#include "SlipThread.h"

/*----------------------------- private constants ----------------------------*/

enum { Thread_table_size = 19 };

static const TXT_type TMT_message = "too many thread registrations";

/*----------------------------------- THR ------------------------------------*/

#define NULL_THREAD (THR_type)Grammar_Null

enum { THR_size = 2 };

typedef struct THR * THR_type;

typedef struct THR { CEL_type hdr;
                     NBR_type tid;
                     THR_type thr; } THR;

static THR_type make_THR_M(NBR_type Thread_id,
                           THR_type Thread,
                           UNS_type Extent)
  { THR_type thread;
    thread = (THR_type)make_VEC_M(THR_size + Extent);
    thread->tid = Thread_id;
    thread->thr = Thread;
    return thread; }

/*----------------------------- private variables ----------------------------*/

static THR_type Current_thread_P;
static UNS_type Thread_counter;
static CCC_type Thread_table[Thread_table_size];

/*----------------------------- public functions -----------------------------*/

VOI_type Thread_Clear(VOI_type)
  { Current_thread_P = NULL_THREAD; }

VEC_type Thread_Keep(VOI_type)
  { return (VEC_type)Current_thread_P; }

VEC_type Thread_Patch(NBR_type Thread_id)
  { Current_thread_P->tid = Thread_id;
    return (VEC_type)Current_thread_P; }

VEC_type Thread_Peek(VOI_type)
  { return (VEC_type)Current_thread_P; }

VEC_type Thread_Poke_M(NBR_type Thread_id,
                       UNS_type Extent)
  { THR_type thread;
    thread = Current_thread_P->thr;
    Current_thread_P = make_THR_M(Thread_id,
                                  thread,
                                  Extent);
    return (VEC_type)Current_thread_P; }

VEC_type Thread_Push_M(NBR_type Thread_id,
                       UNS_type Extent)
  { Current_thread_P = make_THR_M(Thread_id,
                                  Current_thread_P,
                                  Extent);
    return (VEC_type)Current_thread_P; }

NBR_type Thread_Register(CCC_type C_function)
  { NBR_type thread_id;
    if (Thread_counter == Thread_table_size)
      Main_Fatal_Error(TMT_message);
    Thread_table[Thread_counter] = C_function;
    thread_id = make_NBR(Thread_counter++);
    return thread_id; }

CCC_type Thread_Retrieve(VOI_type)
  { NBR_type thread_id;
    UNS_type raw_thread_id;
    thread_id = Current_thread_P->tid;
    raw_thread_id = get_NBR(thread_id);
    return Thread_table[raw_thread_id]; }

VOI_type Thread_Zap(VOI_type)
  { Current_thread_P = Current_thread_P->thr; }

/*------------------------------ initialization ------------------------------*/

VOI_type Thread_Initialize(VOI_type)
  { Current_thread_P = NULL_THREAD;
    Thread_counter = 0;
    REGISTER(Current_thread_P); }
